# frozen_string_literal: true

require 'bubble_sort/version'

# module BubbleSort
module BubbleSort
  class Error < StandardError; end

  # Bubble sort an array IN-PLACE
  def self.bubble_sort(array) # rubocop:disable Metrics/AbcSize
    raise TypeError, 'Given argument is not an array!' unless array.is_a? Array
    raise TypeError, 'Given array contains values which are not numbers!' unless array.all? do |value|
      value.is_a? Numeric
    end

    array[...-1].each_index do |index|
      to = array.length - (index + 1)
      array[...to].each_index do |index2|
        array[index2], array[index2 + 1] = array[index2 + 1], array[index2] if array[index2] > array[index2 + 1]
      end
    end
  end
end
